package ru.dbotthepony.kstarbound.defs.world.dungeon

import com.google.gson.stream.JsonWriter
import ru.dbotthepony.kstarbound.io.IStringSerializable

enum class BeamUpRule(vararg aliases: String) : IStringSerializable {
	NOWHERE,
	ANYWHERE_WITH_WARNING("AnywhereWithWarning"),
	ANYWHERE("Anywhere"),
	;

	private val aliases: Array<String> = Array(aliases.size) { aliases[it].uppercase() }

	override fun match(name: String): Boolean {
		for (alias in aliases)
			if (name == alias)
				return true

		return name == this.name
	}

	override fun write(out: JsonWriter) {
		out.value(this.name)
	}
}
